<?
/**
 * Класс подключения фреймворка
 * @package ru.vbinc.gm.framework.VKontakte
 * @author GreyMag <greymag@gmail.com>
 * @version 0.1
 */
class GMFramework {

	/**
	 * Использовать фреймворк
	 */
	public static function useFramework()
	{
		if( function_exists( '__autoload' ) ) {
			spl_autoload_register( '__autoload' );
		}
		if ( !spl_autoload_register( self::getLoadFunc() ) ) {
			throw new Exception('Could not register class autoload function ');
		}
	}
    
	/**
	 * Отменить регистрацию автолаод-функции
	 */
	protected function unregister() {
		spl_autoload_unregister( self::getLoadFunc() );
	}
    
	/**
	 * Загрузить классы фреймворка
	 * @param string $className
	 */
	public static function loadClass( $className )
	{
		$package = "/";

		switch( $className )
		{
			// amfphp
			case 'AuthInfo'      :
			case 'SecureService' :
			case 'Service'       : $package .= "amfphp/"; break;
			// array
			case 'ArrayList'     : $package .= "array/"; break;
			// datetime
			case 'DateTimeUtils' : $package .= "datetime/"; break;
			// db
			case 'DBConnect'     :
			case 'DBException'   : $package .= "db/"; break;
			// images
			case 'ImageResize'   : $package .= "images/"; break;
			// math
			// math.geom
			case 'Point'         : 
			case 'Rectangle'     : $package .= "math/geom/"; break;
			// net
			case 'FTP'           : $package .= "net/"; break;
			// string
			case 'BaseString'    :
			case 'Validation'    : $package .= "string/"; break;
			// utils
			case 'Globals'       :
			case 'Options'       : 
			case 'Session'       : $package .= "utils/"; break;
			// utils.log
			case 'GMLog'         : 
            case 'GMLogMessage'  : $package .= "utils/log/"; break;
			// VKontakte
			case 'FlashVars'     :
			case 'SecureRequest' :
			case 'VKGlobals'     :
			case 'VKService'     : $package .= "VKontakte/"; break;
			//case ''         : include_once( dirname( __FILE__ ) . '/.class.php' ); break;
			default : return false;
		}

		include_once( dirname( __FILE__ ) . $package . $className . '.class.php' );
	}
    
	/**
	 * Получить имя автолоад-функции
	 * @return string 
	 */
	protected static function getLoadFunc()
	{
		return __CLASS__ . '::loadClass';
	}
}
?>