<?
/**
 * Service
 * Базовый сервис
 * @package ru.vbinc.gm.framework.amfphp
 * @author GreyMag <greymag@gmail.com>
 * @copyright 2009
 * @version 0.7
 * @access public
 */
class Service
{
	/**
	 * Cоединение с БД
	 * @var DBConnect
	 */
	protected $_db;
	
	/**
	 * Успешный результат вызова метода или нет 
	 * @var bool
	 */
	protected $_success = true;
	
	/**
	 * Ассоциативный массив <strong>поле</strong> => <strong>значение</strong>, 
	 * который будет передан в качестве ответа
	 * @var array
	 */
	protected $_answer = array();
	
	/**
	 * Номер ошибки
	 * @var int
	 */
	public $errno = 0;
	/**
	 * Текст ошибки
	 * @var string
	 */
	public $error;

	function __construct( $createDBC = true )
	{
		if( $createDBC ) $this->_db = Globals::getDBConnect();
	}

	/**
	 * Обработка исключения
	 * @param Exception $e
	 * @return array ассоциативный массив ответа на запрос
	 */
	protected function exception( Exception $e )
	{
		return $this->error( $e->getMessage() );
	}

	/**
	 * Ошибка
	 * @param string $message
	 * @param int $errno
     * @return array ассоциативный массив ответа на запрос
	 */
	protected function error( $message = '', $errno = 0 )
	{
		if( !empty( $message ) ) $this->error = $message;
		elseif( !$this->error || $this->error == '' ) $this->error = $this->_db->error;

		if( $errno != 0 ) $this->errno = $errno;

		$this->_success = false;
		
		// а вдруг злобные хацкеры
        sleep( 1 );		

		return $this->answer();
	}

	/**
	 * Добавляет значение в ответ
	 * @param string $name название поля
	 * @param mixed $value добавляемое значение
	 */
	protected function add2Answer( $name, $value )
	{
		$this->_answer[$name] = $value;
	}

	/**
	 * Формирует ответ
     * @return array ассоциативный массив ответа на запрос
	 */
	protected function answer()
	{
		if( !$this->_success )
		{
			$this->_answer = array();
			$this->add2Answer( 'error', $this->error );
			$this->add2Answer( 'errno', $this->errno );
		}

		$this->add2Answer( 'success', $this->_success );

		return $this->_answer;
	}
}
?>